package com.ruoyi.mybasic.common.domain;
import com.alibaba.druid.sql.visitor.functions.Char;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 钱包收支记录表
 * @author WenHao.Sao
 */
@Data
public class MoneyLog {

    /**
     * id
     */
    private Long id;
    /**
     * 用户id
     */
    private Long userId;
    /**
     * 状态 1:支出 2 收入
     */
    private int status;
    /**
     * 操作时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createTime;
    /**
     * 详情
     */
    private String moneyTypeName;
    /**
     * 收入支出金额
     */
    private Integer amountIncome;
    /**
     * 创建人
     */
    private String createBy;
    /**
     * 删除标志
     */
    private Char delFlag;
    /**
     * 修改人
     */
    private String  updateBy;
    /**
     * 修改时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date  updateTime;

}
