package com.ruoyi.mybasic.controller;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.mybasic.service.CardService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;

/**
 * 上传身份证控制层
 * @author Lou_Zs
 */
@RestController
@RequestMapping("/cardUpload")
@Log4j2
public class CardController {

    @Autowired
    private CardService cardService;
    @Autowired
    private HttpServletRequest request;


    /**
     * 上传身份证
     * @param fileFace
     * @param fileBack
     * @return
     */
    @PostMapping("/uploadCardFace")
    public R uploadCardFace(@RequestParam("fileFace")MultipartFile fileFace,@RequestParam("fileBack")MultipartFile fileBack){
        log.info("功能介绍:上传身份证,请求方式:{},请求路径:{},请求参数:{}",
                request.getMethod(),request.getRequestURI(), JSONObject.toJSONString(fileFace+"-"+fileBack));
        //上传身份证正面
        cardService.uploadCardFace(fileFace,fileBack);
        log.info("功能介绍:上传身份证,请求方式:{},请求路径:{},响应结果:{}",
                request.getMethod(),request.getRequestURI(), JSONObject.toJSONString(R.ok()));
        return R.ok();
    }

}
