package com.ruoyi.mybasic.controller;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.mybasic.common.domain.request.ConsultationRequest;
import com.ruoyi.mybasic.common.domain.request.DoctorGiftRecordRequest;
import com.ruoyi.mybasic.common.domain.request.InterrogationRequest;
import com.ruoyi.mybasic.service.FavorableRateService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


/**
 * 好评率-->服务患者次数控制层
 */
@RestController
@RequestMapping("/favorableRate")
@Log4j2
public class FavorableRateController {

    @Autowired
    private FavorableRateService favorableRateService;


    /***
     * 好评率
     * 查询所有完成问诊中有评价的问诊 评价有好评/差评  好评/总数 即是好评率
     * 计算好评率：根据查询结果集，您可以计算好评率。
     * 假设评价表中有一个"rating"状态字段表示评价等级（好评为1，差评为0），
     * 您可以统计好评数量和总评价数量，然后计算好评率
     * 根据问诊信息的id获取到好评表的list展示
     */
    @PostMapping("/reputation")
    public R<List<InterrogationRequest>> reputation(@RequestBody InterrogationRequest interrogation){
        int count = 0;
        int num = 0;
        int sum = 0;
        //首先查询完成问诊的 根据 状态字段判断有没有结束问诊
        List<InterrogationRequest> interrogationStatus = favorableRateService.interrogationStatus(interrogation);
        //如果问诊正在进行
        for (InterrogationRequest status : interrogationStatus) {
            if (status.getStatus() == 0){
                return R.fail("问诊还未结束");
            }else {
                //问诊总数计数
                count++;

                //然后调用上面的的size获取到总数
                interrogation.setCount(count);
                //获取到评价>=3的数量算是好评
                List<InterrogationRequest> evaluateCount = favorableRateService.evaluateCount(status);
                for (InterrogationRequest interrogation1 : evaluateCount) {
//                    计算好评的数量
                    num++;
                }
                sum = (num / count) * 100;

                System.out.println("输出一下好评率 好评数除以结束问诊的数量乘以100等于好评率" + sum + "%");
                //获取到好评的数量
                int evaluate = interrogation.getEvaluate();
                status.setEvaluate(evaluate);
            }
        }
        //再查询所有结束问诊的 评价等级数量 count++这样获取
        return R.ok();
    }

    /***
     * 服务患者次数
     * 通过医生id  查询问诊记录表  查询所有状态为问诊完成的总数即是服务患者次数
     *
     */
    @PostMapping("/countPatient/{userId}")
    public R<List<ConsultationRequest>> countPatient(@PathVariable String userId){

        //调用上面的方法 查询出结束患者的次数
        int goodEvaluationCount = 0;//初始化好评数量

        return favorableRateService.countPatient(userId);
    }

/**
 * 初始化运行测试
 */
//    public static void main(String[] args) {
//        String  sql = "select count * from consultation where doctor_id = ? and status = '问诊完成'";
//        try(Connection connection = DriverManager.getConnection(url , username , password );
//            PreparedStatement statement = connection.prepareStatement(sql)){
//            statement.setInt(1,doctorId);//设置医生ID参数
//            try(ResuilSet resultSet = )
//        }
//    }


    /**
     * 收到礼物的查看礼物记录表关联一个礼物表用于查询图片
     * 根据医生的登录id获取到他的礼物信息
     */
    @PostMapping("giftList/{userId}")
    public R<List<DoctorGiftRecordRequest>> giftList(@PathVariable String userId){
        log.info("获取请求参数" +userId);
        return favorableRateService.giftList(userId);
    }
}
