package com.ruoyi.mybasic.controller;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.mybasic.api.domain.UserMoneyLogs;
import com.ruoyi.mybasic.common.domain.request.RequestInvitationRecord;
import com.ruoyi.mybasic.service.InvitationService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * @ClassName InvitationController
 * @Description 邀请记录的控制层
 * @Author WenHao.Sao
 */

/**
 * 交易控制层
 * @author Lou_Zs
 */
@RestController
@RequestMapping("/Invitation")
@Log4j2
public class InvitationController {

    @Autowired
    private InvitationService invitationService;
    @Autowired
    private HttpServletRequest request;


    /**
     * 新用户注册邀请获利
     * @param requestInvitationRecord
     * @return
     */
    @PostMapping("/UserInviteTask")
    public R UserInviteTask(@RequestBody RequestInvitationRecord requestInvitationRecord){
        log.info("功能介绍:新用户邀请,请求方式:{},请求路径:{},请求参数:{}",
                request.getMethod(),request.getRequestURI(), JSONObject.toJSONString(requestInvitationRecord));
        //邀请新用户
        invitationService.UserInviteTask(requestInvitationRecord);
        log.info("功能介绍:新用户邀请,请求方式:{},请求路径:{},响应结果:{}",
                request.getMethod(),request.getRequestURI(),JSONObject.toJSONString(R.ok()));
        return R.ok();
    }


    /**
     * 根据记录处理金额
     * @param userMoneyLogs
     * @return
     */
    @PostMapping("/updatePurseByLogs")
    public R updatePurseByLogsMoney(@RequestBody UserMoneyLogs userMoneyLogs){
        log.info("功能介绍:根据记录处理金额,请求方式:{},请求路径:{},请求参数:{}",
                request.getMethod(),request.getRequestURI(),JSONObject.toJSONString(userMoneyLogs));
        invitationService.updatePurseByLogs(userMoneyLogs);
        log.info("功能介绍:根据记录处理金额,请求方式:{},请求路劲:{},响应结果:{}",
                request.getMethod(),request.getRequestURI(),JSONObject.toJSONString(R.ok()));
        return R.ok();
    }

}
