package com.ruoyi.mybasic.util;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONPObject;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.exception.ServiceException;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.mybasic.common.domain.BankConfig;
import com.ruoyi.mybasic.mapper.MessageMapper;
import org.apache.http.HttpResponse;
import org.apache.http.util.EntityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 银行扫描工具类
 */
@Component
public class BankScan {

    /** @noinspection SpringJavaInjectionPointsAutowiringInspection*/
    @Autowired
    private MessageMapper messageMapper;

    @Autowired
    private UploadUtil uploadUtil;

    public String BankScan(MultipartFile file){
        OutputStream outputStream = null;
        //上传文件方法
        if (null == file){
            throw new ServiceException("银行卡照片为空");
        }
        String upload = uploadUtil.upload(file);

        String host = "https://vbkocr.market.alicloudapi.com";
        String path = "/lundear/bkocr";
        String method = "POST";
        String appcode = "ded4e72aaf8f48499dcd2ef13f8eaae9";
        Map<String, String> headers = new HashMap<String, String>();
        //最后在header中的格式(中间是英文空格)为Authorization:APPCODE 83359fd73fe94948385f570e3c139105
        headers.put("Authorization", "APPCODE " + appcode);
        //根据API的要求，定义相对应的Content-Type
        headers.put("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        Map<String, String> querys = new HashMap<String, String>();
        Map<String, String> bodys = new HashMap<String, String>();
        bodys.put("url", upload);
        System.out.println(bodys);

        try {
            /**
             * 重要提示如下:
             * HttpUtils请从
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/src/main/java/com/aliyun/api/gateway/demo/util/HttpUtils.java
             * 下载
             *
             * 相应的依赖请参照
             * https://github.com/aliyun/api-gateway-demo-sign-java/blob/master/pom.xml
             */
            HttpResponse response = HttpUtils.doPost(host, path, method, headers, querys, bodys);
            System.out.println("response:"+response.toString());

            String string = EntityUtils.toString(response.getEntity());
            JSONObject jsonObject = JSONObject.parseObject(string);
            //获取response的body
//            JSONObject jsonObject = JSONObject.parseObject(EntityUtils.toString(response.getEntity()));
            System.out.println("jsonObject数据为:" + jsonObject);

            bodys.clear();//用于清空bodys路径数据
            System.out.println("上一个路径 数据清空");

            BankConfig bankConfig = new BankConfig();
            //查询当前人银行卡的当前银行卡 根据银行卡号进行循环查询 是否已经绑定

                //转成字符串
                BankConfig bankConfig1 = JSONObject.parseObject(jsonObject.getString("data"), BankConfig.class);

                //判断银行卡的bankId 是不是唯一
                BankConfig bankConfig2 = messageMapper.selectBankId(bankConfig1.getBankId());
                if (bankConfig2 != null){
                    return "已经添加过此银行卡!换一张";
//                    throw new ServiceException("已经添加过此银行卡!换一张");
                }
                //存值
                bankConfig.setBankCode(bankConfig1.getBankCode());
                bankConfig.setCardType(bankConfig1.getCardType());
                bankConfig.setCardNo(bankConfig1.getCardNo());
                bankConfig.setBankName(bankConfig1.getBankName());
                bankConfig.setBankId(bankConfig1.getBankId());
                bankConfig.setUserId(SecurityUtils.getUserId());

                //绑定银行卡 添加到银行卡表中
                messageMapper.addBank(bankConfig);

                System.out.println("添加成功");


        } catch (Exception e) {
            e.printStackTrace();
        }
        return "成功";
    }

}
